Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h	(revision 971)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspBspTree.h	(revision 1004)
@@ -28,5 +28,5 @@
 class Beam;
 class ViewCellsTree;
-class Environment;
+//class Environment;
 
 /**
@@ -201,10 +201,4 @@
 	VspBspTree();
 
-	
-	/** Constructor creating an empty tree. Loads parameters 
-		from an environment file.
-	*/ 
-	VspBspTree(Environment *env);
-
 	/** Default destructor.
 	*/
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.cpp	(revision 1004)
@@ -354,5 +354,5 @@
 
 
-ViewCellsTree::ViewCellsTree(ViewCellsManager *vcm, Environment *env):
+ViewCellsTree::ViewCellsTree(ViewCellsManager *vcm):
 mRoot(NULL),
 mUseAreaForPvs(false),
@@ -364,15 +364,15 @@
 #endif
 {
-	env->GetBoolValue("ViewCells.Visualization.exportMergedViewCells", mExportMergedViewCells);
-	env->GetFloatValue("ViewCells.maxStaticMemory", mMaxMemory);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.Visualization.exportMergedViewCells", mExportMergedViewCells);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.maxStaticMemory", mMaxMemory);
 
 	//-- merge options
-	env->GetFloatValue("ViewCells.PostProcess.renderCostWeight", mRenderCostWeight);
-	env->GetIntValue("ViewCells.PostProcess.minViewCells", mMergeMinViewCells);
-	env->GetFloatValue("ViewCells.PostProcess.maxCostRatio", mMergeMaxCostRatio);
-	env->GetBoolValue("ViewCells.PostProcess.refine", mRefineViewCells);	
-
-	env->GetIntValue("ViewCells.PostProcess.maxMergesPerPass", mMaxMergesPerPass);
-	env->GetFloatValue("ViewCells.PostProcess.avgCostMaxDeviation", mAvgCostMaxDeviation);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.PostProcess.renderCostWeight", mRenderCostWeight);
+	Environment::GetSingleton()->GetIntValue("ViewCells.PostProcess.minViewCells", mMergeMinViewCells);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.PostProcess.maxCostRatio", mMergeMaxCostRatio);
+	Environment::GetSingleton()->GetBoolValue("ViewCells.PostProcess.refine", mRefineViewCells);	
+
+	Environment::GetSingleton()->GetIntValue("ViewCells.PostProcess.maxMergesPerPass", mMaxMergesPerPass);
+	Environment::GetSingleton()->GetFloatValue("ViewCells.PostProcess.avgCostMaxDeviation", mAvgCostMaxDeviation);
 
 	Debug << "============= view cell tree options ================\n";
Index: GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.cpp	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/LogManager.cpp	(revision 1004)
@@ -1,3 +1,5 @@
 #include "LogManager.h"
+#include "common.h"
+
 using namespace std;
 
@@ -18,4 +20,10 @@
 
 
+void LogManager::DelSingleton()
+{
+	DEL_PTR(sLogManager);
+}
+
+
 LogManager::LogManager()
 {
Index: GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/UnigraphicsParser.cpp	(revision 1004)
@@ -65,5 +65,5 @@
 
   int meshGrouping;
-  environment->GetIntValue("Unigraphics.meshGrouping",
+  Environment::GetSingleton()->GetIntValue("Unigraphics.meshGrouping",
 			   meshGrouping);
   
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.h	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Mesh.h	(revision 1004)
@@ -256,8 +256,5 @@
   }
 
-  virtual int
-  CastRay(
-	  Ray &ray
-	  );
+  virtual int CastRay(Ray &ray);
 
   virtual bool IsConvex() { return mMesh->mIsConvex; }
@@ -303,5 +300,5 @@
 	class if the same mesh should be instantiated on different places.
 */
-class TransformedMeshInstance : public MeshInstance
+class TransformedMeshInstance: public MeshInstance
 {
 public:
@@ -313,4 +310,6 @@
   virtual int CastRay(Ray &ray);
 
+  virtual int CastRay(Ray &ray, const vector<int> &faces);
+
   virtual int Type() const { return TRANSFORMED_MESH_INSTANCE; }
 
@@ -329,5 +328,5 @@
   void GetWorldTransform(Matrix4x4 &m);
 
-  /** Transforms mesh-
+  /** Transforms a mesh according to the stored world transform.
 	@param transformedMesh returns the tranformed mesh.
   */
Index: GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/KdTree.cpp	(revision 1004)
@@ -36,15 +36,15 @@
   
   mRoot = new KdLeaf(NULL, 0);
-  environment->GetIntValue("KdTree.Termination.maxNodes", mTermMaxNodes);
-  environment->GetIntValue("KdTree.Termination.maxDepth", mTermMaxDepth);
-  environment->GetIntValue("KdTree.Termination.minCost", mTermMinCost);
-  environment->GetFloatValue("KdTree.Termination.maxCostRatio", mMaxCostRatio);
-  environment->GetFloatValue("KdTree.Termination.ct_div_ci", mCt_div_ci);
-  environment->GetFloatValue("KdTree.splitBorder", mSplitBorder);
-
-  environment->GetBoolValue("KdTree.sahUseFaces", mSahUseFaces);
+  Environment::GetSingleton()->GetIntValue("KdTree.Termination.maxNodes", mTermMaxNodes);
+  Environment::GetSingleton()->GetIntValue("KdTree.Termination.maxDepth", mTermMaxDepth);
+  Environment::GetSingleton()->GetIntValue("KdTree.Termination.minCost", mTermMinCost);
+  Environment::GetSingleton()->GetFloatValue("KdTree.Termination.maxCostRatio", mMaxCostRatio);
+  Environment::GetSingleton()->GetFloatValue("KdTree.Termination.ct_div_ci", mCt_div_ci);
+  Environment::GetSingleton()->GetFloatValue("KdTree.splitBorder", mSplitBorder);
+
+  Environment::GetSingleton()->GetBoolValue("KdTree.sahUseFaces", mSahUseFaces);
 
   char splitType[64];
-  environment->GetStringValue("KdTree.splitMethod", splitType);
+  Environment::GetSingleton()->GetStringValue("KdTree.splitMethod", splitType);
   
   mSplitMethod = SPLIT_SPATIAL_MEDIAN;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCell.h	(revision 1004)
@@ -24,5 +24,5 @@
 class ViewCellsManager;
 class ViewCellLeaf;
-class Environment;
+//class Environment;
 
 
@@ -393,8 +393,7 @@
 
 public:
-	/** View cells tree constructor taking a view cell mnanager and
-		an environment as parameters.
-	*/
-	ViewCellsTree(ViewCellsManager *vcm, Environment *env);
+	/** View cells tree constructor taking a view cell mnanager as parameter
+	*/
+	ViewCellsTree(ViewCellsManager *vcm);
 	~ViewCellsTree();
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/RssTree.cpp	(revision 1004)
@@ -107,29 +107,29 @@
 RssTree::RssTree()
 {
-  environment->GetIntValue("RssTree.maxDepth", termMaxDepth);
-  environment->GetIntValue("RssTree.minPvs", termMinPvs);
-  environment->GetIntValue("RssTree.minRays", termMinRays);
-  environment->GetFloatValue("RssTree.maxRayContribution", termMaxRayContribution);
-  environment->GetFloatValue("RssTree.maxCostRatio", termMaxCostRatio);
-
-  environment->GetFloatValue("RssTree.minSize", termMinSize);
+  Environment::GetSingleton()->GetIntValue("RssTree.maxDepth", termMaxDepth);
+  Environment::GetSingleton()->GetIntValue("RssTree.minPvs", termMinPvs);
+  Environment::GetSingleton()->GetIntValue("RssTree.minRays", termMinRays);
+  Environment::GetSingleton()->GetFloatValue("RssTree.maxRayContribution", termMaxRayContribution);
+  Environment::GetSingleton()->GetFloatValue("RssTree.maxCostRatio", termMaxCostRatio);
+
+  Environment::GetSingleton()->GetFloatValue("RssTree.minSize", termMinSize);
   termMinSize = sqr(termMinSize);
 	
-  environment->GetFloatValue("RssTree.refDirBoxMaxSize", refDirBoxMaxSize);
+  Environment::GetSingleton()->GetFloatValue("RssTree.refDirBoxMaxSize", refDirBoxMaxSize);
   refDirBoxMaxSize = sqr(refDirBoxMaxSize);
   
-  environment->GetFloatValue("RssTree.epsilon", epsilon);
-  environment->GetFloatValue("RssTree.ct_div_ci", ct_div_ci);
-	
-  environment->GetFloatValue("RssTree.maxTotalMemory", maxTotalMemory);
-  environment->GetFloatValue("RssTree.maxStaticMemory", maxStaticMemory);
-  
-  environment->GetFloatValue("RssTree.maxStaticMemory", maxStaticMemory);
-
-
-  
-  environment->GetIntValue("RssTree.accessTimeThreshold", accessTimeThreshold);
+  Environment::GetSingleton()->GetFloatValue("RssTree.epsilon", epsilon);
+  Environment::GetSingleton()->GetFloatValue("RssTree.ct_div_ci", ct_div_ci);
+	
+  Environment::GetSingleton()->GetFloatValue("RssTree.maxTotalMemory", maxTotalMemory);
+  Environment::GetSingleton()->GetFloatValue("RssTree.maxStaticMemory", maxStaticMemory);
+  
+  Environment::GetSingleton()->GetFloatValue("RssTree.maxStaticMemory", maxStaticMemory);
+
+
+  
+  Environment::GetSingleton()->GetIntValue("RssTree.accessTimeThreshold", accessTimeThreshold);
   //= 1000;
-  environment->GetIntValue("RssTree.minCollapseDepth", minCollapseDepth);
+  Environment::GetSingleton()->GetIntValue("RssTree.minCollapseDepth", minCollapseDepth);
   //  int minCollapseDepth = 4;
 
@@ -141,5 +141,5 @@
   // split type
   char sname[128];
-  environment->GetStringValue("RssTree.splitType", sname);
+  Environment::GetSingleton()->GetStringValue("RssTree.splitType", sname);
   string name(sname);
 	
@@ -157,15 +157,15 @@
 	  }
 	
-  environment->GetBoolValue("RssTree.randomize", randomize);
-  environment->GetBoolValue("RssTree.splitUseOnlyDrivingAxis", mSplitUseOnlyDrivingAxis);
-
-  environment->GetBoolValue("RssTree.interleaveDirSplits", mInterleaveDirSplits);
-  environment->GetIntValue("RssTree.dirSplitDepth", mDirSplitDepth);
-
-  environment->GetBoolValue("RssTree.importanceBasedCost", mImportanceBasedCost);
-  
-  environment->GetIntValue("RssTree.maxRays", mMaxRays);
-
-  environment->GetBoolValue("RssTree.perObjectTree", mPerObjectTree);
+  Environment::GetSingleton()->GetBoolValue("RssTree.randomize", randomize);
+  Environment::GetSingleton()->GetBoolValue("RssTree.splitUseOnlyDrivingAxis", mSplitUseOnlyDrivingAxis);
+
+  Environment::GetSingleton()->GetBoolValue("RssTree.interleaveDirSplits", mInterleaveDirSplits);
+  Environment::GetSingleton()->GetIntValue("RssTree.dirSplitDepth", mDirSplitDepth);
+
+  Environment::GetSingleton()->GetBoolValue("RssTree.importanceBasedCost", mImportanceBasedCost);
+  
+  Environment::GetSingleton()->GetIntValue("RssTree.maxRays", mMaxRays);
+
+  Environment::GetSingleton()->GetBoolValue("RssTree.perObjectTree", mPerObjectTree);
   
   //  mRoots;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VssTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VssTree.cpp	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VssTree.cpp	(revision 1004)
@@ -67,21 +67,21 @@
 VssTree::VssTree()
 {
-  environment->GetIntValue("VssTree.maxDepth", termMaxDepth);
-  environment->GetIntValue("VssTree.minPvs", termMinPvs);
-  environment->GetIntValue("VssTree.minRays", termMinRays);
-  environment->GetFloatValue("VssTree.maxRayContribution", termMaxRayContribution);
-  environment->GetFloatValue("VssTree.maxCostRatio", termMaxCostRatio);
-
-  environment->GetFloatValue("VssTree.minSize", termMinSize);
+  Environment::GetSingleton()->GetIntValue("VssTree.maxDepth", termMaxDepth);
+  Environment::GetSingleton()->GetIntValue("VssTree.minPvs", termMinPvs);
+  Environment::GetSingleton()->GetIntValue("VssTree.minRays", termMinRays);
+  Environment::GetSingleton()->GetFloatValue("VssTree.maxRayContribution", termMaxRayContribution);
+  Environment::GetSingleton()->GetFloatValue("VssTree.maxCostRatio", termMaxCostRatio);
+
+  Environment::GetSingleton()->GetFloatValue("VssTree.minSize", termMinSize);
   termMinSize = sqr(termMinSize);
 	
-  environment->GetFloatValue("VssTree.refDirBoxMaxSize", refDirBoxMaxSize);
+  Environment::GetSingleton()->GetFloatValue("VssTree.refDirBoxMaxSize", refDirBoxMaxSize);
   refDirBoxMaxSize = sqr(refDirBoxMaxSize);
   
-  environment->GetFloatValue("VssTree.epsilon", epsilon);
-  environment->GetFloatValue("VssTree.ct_div_ci", ct_div_ci);
-	
-  environment->GetFloatValue("VssTree.maxTotalMemory", maxTotalMemory);
-  environment->GetFloatValue("VssTree.maxStaticMemory", maxStaticMemory);
+  Environment::GetSingleton()->GetFloatValue("VssTree.epsilon", epsilon);
+  Environment::GetSingleton()->GetFloatValue("VssTree.ct_div_ci", ct_div_ci);
+	
+  Environment::GetSingleton()->GetFloatValue("VssTree.maxTotalMemory", maxTotalMemory);
+  Environment::GetSingleton()->GetFloatValue("VssTree.maxStaticMemory", maxStaticMemory);
   
   
@@ -89,9 +89,9 @@
 
   float refDirAngle;
-  environment->GetFloatValue("VssTree.refDirAngle", refDirAngle);
-  
-  environment->GetIntValue("VssTree.accessTimeThreshold", accessTimeThreshold);
+  Environment::GetSingleton()->GetFloatValue("VssTree.refDirAngle", refDirAngle);
+  
+  Environment::GetSingleton()->GetIntValue("VssTree.accessTimeThreshold", accessTimeThreshold);
   //= 1000;
-  environment->GetIntValue("VssTree.minCollapseDepth", minCollapseDepth);
+  Environment::GetSingleton()->GetIntValue("VssTree.minCollapseDepth", minCollapseDepth);
   //  int minCollapseDepth = 4;
 
@@ -103,5 +103,5 @@
   // split type
   char sname[128];
-  environment->GetStringValue("VssTree.splitType", sname);
+  Environment::GetSingleton()->GetStringValue("VssTree.splitType", sname);
   string name(sname);
 	
@@ -119,10 +119,10 @@
 	  }
 	
-  environment->GetBoolValue("VssTree.randomize", randomize);
-  environment->GetBoolValue("VssTree.splitUseOnlyDrivingAxis", mSplitUseOnlyDrivingAxis);
-  environment->GetBoolValue("VssTree.useRss", mUseRss);
-
-  environment->GetBoolValue("VssTree.interleaveDirSplits", mInterleaveDirSplits);
-  environment->GetIntValue("VssTree.dirSplitDepth", mDirSplitDepth);
+  Environment::GetSingleton()->GetBoolValue("VssTree.randomize", randomize);
+  Environment::GetSingleton()->GetBoolValue("VssTree.splitUseOnlyDrivingAxis", mSplitUseOnlyDrivingAxis);
+  Environment::GetSingleton()->GetBoolValue("VssTree.useRss", mUseRss);
+
+  Environment::GetSingleton()->GetBoolValue("VssTree.interleaveDirSplits", mInterleaveDirSplits);
+  Environment::GetSingleton()->GetIntValue("VssTree.dirSplitDepth", mDirSplitDepth);
 
   root = NULL;
Index: GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/FromPointVisibilityTree.cpp	(revision 1004)
@@ -67,69 +67,69 @@
 {
 	bool randomize = false;
-	environment->GetBoolValue("FromPointVisibilityTree.Construction.randomize", randomize);
+	Environment::GetSingleton()->GetBoolValue("FromPointVisibilityTree.Construction.randomize", randomize);
 	if (randomize)
 		Randomize(); // initialise random generator for heuristics
 
 	//-- termination criteria for autopartition
-	environment->GetIntValue("FromPointVisibilityTree.Termination.maxDepth", mTermMaxDepth);
-	environment->GetIntValue("FromPointVisibilityTree.Termination.minPvs", mTermMinPvs);
-	environment->GetIntValue("FromPointVisibilityTree.Termination.minRays", mTermMinRays);
-	environment->GetFloatValue("FromPointVisibilityTree.Termination.minProbability", mTermMinProbability);
-	environment->GetFloatValue("FromPointVisibilityTree.Termination.maxRayContribution", mTermMaxRayContribution);
-	environment->GetFloatValue("FromPointVisibilityTree.Termination.minAccRayLenght", mTermMinAccRayLength);
-	environment->GetFloatValue("FromPointVisibilityTree.Termination.maxCostRatio", mTermMaxCostRatio);
-	environment->GetIntValue("FromPointVisibilityTree.Termination.missTolerance", mTermMissTolerance);
-	environment->GetIntValue("FromPointVisibilityTree.Termination.maxViewCells", mMaxViewCells);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.Termination.maxDepth", mTermMaxDepth);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.Termination.minPvs", mTermMinPvs);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.Termination.minRays", mTermMinRays);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Termination.minProbability", mTermMinProbability);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Termination.maxRayContribution", mTermMaxRayContribution);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Termination.minAccRayLenght", mTermMinAccRayLength);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Termination.maxCostRatio", mTermMaxCostRatio);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.Termination.missTolerance", mTermMissTolerance);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.Termination.maxViewCells", mMaxViewCells);
 
 	//-- max cost ratio for early tree termination
-	environment->GetFloatValue("FromPointVisibilityTree.Termination.maxCostRatio", mTermMaxCostRatio);
-
-	environment->GetFloatValue("FromPointVisibilityTree.Termination.minGlobalCostRatio", mTermMinGlobalCostRatio);
-	environment->GetIntValue("FromPointVisibilityTree.Termination.globalCostMissTolerance", mTermGlobalCostMissTolerance);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Termination.maxCostRatio", mTermMaxCostRatio);
+
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Termination.minGlobalCostRatio", mTermMinGlobalCostRatio);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.Termination.globalCostMissTolerance", mTermGlobalCostMissTolerance);
 
 	// HACK//mTermMinPolygons = 25;
 
 	//-- factors for bsp tree split plane heuristics
-	environment->GetFloatValue("FromPointVisibilityTree.Factor.pvs", mPvsFactor);
-	environment->GetFloatValue("FromPointVisibilityTree.Termination.ct_div_ci", mCtDivCi);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Factor.pvs", mPvsFactor);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Termination.ct_div_ci", mCtDivCi);
 
 
 	//-- partition criteria
-	environment->GetIntValue("FromPointVisibilityTree.maxPolyCandidates", mMaxPolyCandidates);
-	environment->GetIntValue("FromPointVisibilityTree.maxRayCandidates", mMaxRayCandidates);
-	environment->GetIntValue("FromPointVisibilityTree.splitPlaneStrategy", mSplitPlaneStrategy);
-
-	environment->GetFloatValue("FromPointVisibilityTree.Construction.epsilon", mEpsilon);
-	environment->GetIntValue("FromPointVisibilityTree.maxTests", mMaxTests);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.maxPolyCandidates", mMaxPolyCandidates);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.maxRayCandidates", mMaxRayCandidates);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.splitPlaneStrategy", mSplitPlaneStrategy);
+
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Construction.epsilon", mEpsilon);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.maxTests", mMaxTests);
 
 	// if only the driving axis is used for axis aligned split
-	environment->GetBoolValue("FromPointVisibilityTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
+	Environment::GetSingleton()->GetBoolValue("FromPointVisibilityTree.splitUseOnlyDrivingAxis", mOnlyDrivingAxis);
 	
 	//-- termination criteria for axis aligned split
-	environment->GetFloatValue("FromPointVisibilityTree.Termination.AxisAligned.maxRayContribution", 
-								mTermMaxRayContriForAxisAligned);
-	environment->GetIntValue("FromPointVisibilityTree.Termination.AxisAligned.minRays",
-							 mTermMinRaysForAxisAligned);
-
-	//environment->GetFloatValue("FromPointVisibilityTree.maxTotalMemory", mMaxTotalMemory);
-	environment->GetFloatValue("FromPointVisibilityTree.maxStaticMemory", mMaxMemory);
-
-	environment->GetFloatValue("FromPointVisibilityTree.Construction.renderCostWeight", mRenderCostWeight);
-	environment->GetBoolValue("FromPointVisibilityTree.usePolygonSplitIfAvailable", mUsePolygonSplitIfAvailable);
-
-	environment->GetBoolValue("FromPointVisibilityTree.useCostHeuristics", mUseCostHeuristics);
-	environment->GetBoolValue("FromPointVisibilityTree.useSplitCostQueue", mUseSplitCostQueue);
-	environment->GetBoolValue("FromPointVisibilityTree.simulateOctree", mCirculatingAxis);
-	environment->GetBoolValue("FromPointVisibilityTree.useRandomAxis", mUseRandomAxis);
-	environment->GetIntValue("FromPointVisibilityTree.nodePriorityQueueType", mNodePriorityQueueType);
-
-	environment->GetBoolValue("ViewCells.PostProcess.emptyViewCellsMerge", mEmptyViewCellsMergeAllowed);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Termination.AxisAligned.maxRayContribution", 
+												mTermMaxRayContriForAxisAligned);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.Termination.AxisAligned.minRays",
+											  mTermMinRaysForAxisAligned);
+
+	//Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.maxTotalMemory", mMaxTotalMemory);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.maxStaticMemory", mMaxMemory);
+
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Construction.renderCostWeight", mRenderCostWeight);
+	Environment::GetSingleton()->GetBoolValue("FromPointVisibilityTree.usePolygonSplitIfAvailable", mUsePolygonSplitIfAvailable);
+
+	Environment::GetSingleton()->GetBoolValue("FromPointVisibilityTree.useCostHeuristics", mUseCostHeuristics);
+	Environment::GetSingleton()->GetBoolValue("FromPointVisibilityTree.useSplitCostQueue", mUseSplitCostQueue);
+	Environment::GetSingleton()->GetBoolValue("FromPointVisibilityTree.simulateOctree", mCirculatingAxis);
+	Environment::GetSingleton()->GetBoolValue("FromPointVisibilityTree.useRandomAxis", mUseRandomAxis);
+	Environment::GetSingleton()->GetIntValue("FromPointVisibilityTree.nodePriorityQueueType", mNodePriorityQueueType);
+
+	Environment::GetSingleton()->GetBoolValue("ViewCells.PostProcess.emptyViewCellsMerge", mEmptyViewCellsMergeAllowed);
 	
 	char subdivisionStatsLog[100];
-	environment->GetStringValue("FromPointVisibilityTree.subdivisionStats", subdivisionStatsLog);
+	Environment::GetSingleton()->GetStringValue("FromPointVisibilityTree.subdivisionStats", subdivisionStatsLog);
 	mSubdivisionStats.open(subdivisionStatsLog);
 
-	environment->GetFloatValue("FromPointVisibilityTree.Construction.minBand", mMinBand);
-	environment->GetFloatValue("FromPointVisibilityTree.Construction.maxBand", mMaxBand);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Construction.minBand", mMinBand);
+	Environment::GetSingleton()->GetFloatValue("FromPointVisibilityTree.Construction.maxBand", mMaxBand);
 
 	//-- debug output
Index: GTP/trunk/Lib/Vis/Preprocessing/src/Environment.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/Environment.h	(revision 938)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/Environment.h	(revision 1004)
@@ -174,15 +174,17 @@
 
 public:  
-  /**@name Methods */
-  //@{
-  /// Constructor of the CEnvironment class.
-  Environment();
-  /// Destructor of the CEnvironment class.
-  virtual ~Environment();
-  
-  /// This method is used as a help on available command line options.
-  virtual void PrintUsage(ostream &s) const;
-
-  virtual void SetStaticOptions();
+	
+public:
+
+	/** Returns the resource manager as a singleton.
+	*/
+	static Environment *GetSingleton();
+
+	static void DelSingleton();
+
+    /// This method is used as a help on available command line options.
+	virtual void PrintUsage(ostream &s) const;
+
+	virtual void SetStaticOptions();
 
 
@@ -312,6 +314,6 @@
   /// returns named option as a character string.
   bool GetStringValue(const char *name,
-											char *value,
-											const bool isFatal = false) const;
+					  char *value,
+					  const bool isFatal = false) const;
   
   //@}
@@ -348,8 +350,19 @@
 		char *filenameCoded);
 
+protected:
+
+	/**@name Methods */  //@{
+  /// Constructor of the CEnvironment class.
+  Environment();
+  /// Destructor of the CEnvironment class.
+  virtual ~Environment();
+
+private:
+
+	static Environment *sEnvironment;
 };
 
 // global environment value
-extern Environment *environment;
+//extern Environment *environment;
 
 }
Index: GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/main.cpp	(revision 1004)
@@ -40,11 +40,10 @@
 
   Debug.open("debug.log");
-  environment = new Environment;
- 
-  environment->Parse(argc, argv, USE_EXE_PATH);
+  
+  Environment::GetSingleton()->Parse(argc, argv, USE_EXE_PATH);
   MeshKdTree::ParseEnvironment();
 
   char buff[128];
-  environment->GetStringValue("Preprocessor.type", buff);
+  Environment::GetSingleton()->GetStringValue("Preprocessor.type", buff);
   string preprocessorType(buff);
 
@@ -81,5 +80,5 @@
 		  }
 		  else {
-			  DEL_PTR(environment);
+			  Environment::DelSingleton();
 			  cerr<<"Unknown preprocessor type"<<endl;
 			  Debug<<"Unknown preprocessor type"<<endl;
@@ -109,5 +108,5 @@
   preprocessor = p;
   
-  environment->GetStringValue("Scene.filename", buff);
+  Environment::GetSingleton()->GetStringValue("Scene.filename", buff);
   string filename(buff);
   p->LoadScene(filename);
@@ -166,5 +165,5 @@
   //-- clean up
   DEL_PTR(p);
-  DEL_PTR(environment);
+  Environment::DelSingleton();
 
   MeshManager::DelSingleton();
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ResourceManager.h	(revision 1004)
@@ -38,4 +38,6 @@
 	}
 
+	/** We also want full control over the delete.
+	*/
 	static void DelSingleton()
 	{
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParserXerces.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParserXerces.h	(revision 955)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParserXerces.h	(revision 1004)
@@ -29,5 +29,5 @@
   //  Constructors and Destructor
   // -----------------------------------------------------------------------
-  ViewCellsParseHandlers(ObjectContainer *objects, BoundingBoxConverter *bconverter, Environment *env);
+  ViewCellsParseHandlers(ObjectContainer *objects, BoundingBoxConverter *bconverter);
   ~ViewCellsParseHandlers();
   
@@ -85,6 +85,5 @@
 
   IndexedBoundingBoxContainer mIBoundingBoxes;
-  Environment *mEnvironment;
-
+ 
   bool mParseViewCells;
 
Index: GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h	(revision 1001)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/GlRenderer.h	(revision 1004)
@@ -366,6 +366,6 @@
   virtual int GetHeight() const { return height(); }
 
-  virtual void
-  SetupProjection(const int w, const int h);
+ virtual void
+  SetupProjection(const int w, const int h, const float angle = 70.0f);
 
   void
Index: GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 975)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/ViewCellsParser.cpp	(revision 1004)
@@ -67,6 +67,5 @@
 // ---------------------------------------------------------------------------
 ViewCellsParseHandlers::ViewCellsParseHandlers(ObjectContainer *objects, 
-											   BoundingBoxConverter *bconverter,
-											   Environment *env):
+											   BoundingBoxConverter *bconverter):
   mElementCount(0)
   , mAttrCount(0)
@@ -82,5 +81,4 @@
   , mObjects(objects)
   , mBoundingBoxConverter(bconverter)
-  , mEnvironment(env)
 {
 }
@@ -622,5 +620,5 @@
 		//mCurrentBspNode = mBspTree->GetRoot();
 
-		mViewCellsManager = new BspViewCellsManager(mBspTree, mEnvironment);
+		mViewCellsManager = new BspViewCellsManager(mBspTree);
 	}
 	
@@ -630,5 +628,5 @@
 		Debug << "view cell type: VspKd" << endl;
 		mVspKdTree = new VspKdTree();	
-		mViewCellsManager = new VspKdViewCellsManager(mVspKdTree, mEnvironment);
+		mViewCellsManager = new VspKdViewCellsManager(mVspKdTree);
 	}
 	else // vspBspTree
@@ -638,5 +636,5 @@
 		mVspBspTree = new VspBspTree();
 		//mCurrentBspNode = mVspBspTree->GetRoot();
-		mViewCellsManager = new VspBspViewCellsManager(mVspBspTree, mEnvironment);
+		mViewCellsManager = new VspBspViewCellsManager(mVspBspTree);
 
 		mVspBspTree->mBox = mViewSpaceBox;
@@ -705,6 +703,5 @@
 								ViewCellsManager **viewCells,
 								ObjectContainer *objects,
-								BoundingBoxConverter *bconverter,
-								Environment *env)
+								BoundingBoxConverter *bconverter)
 {
   // Initialize the XML4C system
@@ -737,5 +734,5 @@
   //  to do.
   //
-  ViewCellsParseHandlers handler(objects, bconverter, env);
+  ViewCellsParseHandlers handler(objects, bconverter);
   parser->setDocumentHandler(&handler);
   parser->setErrorHandler(&handler);
Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.h
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.h	(revision 860)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspKdTree.h	(revision 1004)
@@ -277,8 +277,8 @@
 	/** Returns back child.
 	*/
-	inline VspKdNode *GetBack() const;
+	VspKdNode *GetBack() const;
 	/** Returns front child.
 	*/
-	inline VspKdNode *GetFront() const;
+	VspKdNode *GetFront() const;
 
 protected:
Index: GTP/trunk/Lib/Vis/Preprocessing/src/MeshKdTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/MeshKdTree.cpp	(revision 863)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/MeshKdTree.cpp	(revision 1004)
@@ -25,12 +25,12 @@
 MeshKdTree::ParseEnvironment()
 {
-  environment->GetIntValue("MeshKdTree.Termination.maxDepth", mTermMaxDepth);
-  environment->GetIntValue("MeshKdTree.Termination.minCost", mTermMinCost);
-  environment->GetFloatValue("MeshKdTree.Termination.maxCostRatio", mMaxCostRatio);
-  environment->GetFloatValue("MeshKdTree.Termination.ct_div_ci", mCt_div_ci);
-  environment->GetFloatValue("MeshKdTree.splitBorder", mSplitBorder);
+  Environment::GetSingleton()->GetIntValue("MeshKdTree.Termination.maxDepth", mTermMaxDepth);
+  Environment::GetSingleton()->GetIntValue("MeshKdTree.Termination.minCost", mTermMinCost);
+  Environment::GetSingleton()->GetFloatValue("MeshKdTree.Termination.maxCostRatio", mMaxCostRatio);
+  Environment::GetSingleton()->GetFloatValue("MeshKdTree.Termination.ct_div_ci", mCt_div_ci);
+  Environment::GetSingleton()->GetFloatValue("MeshKdTree.splitBorder", mSplitBorder);
   
   char splitType[64];
-  environment->GetStringValue("MeshKdTree.splitMethod", splitType);
+  Environment::GetSingleton()->GetStringValue("MeshKdTree.splitMethod", splitType);
   
   mSplitMethod = SPLIT_SPATIAL_MEDIAN;
